{$D+}
UNIT Dict20;

INTERFACE

TYPE   SCHLUESSEL = LONGINT;
     I_SCHLUESSEL = LONGINT;
     S_SCHLUESSEL = {$IFDEF DOS} STRING[80] {$ELSE} STRING {$ENDIF};

(* die allgemeinen Dict-Funktionen funktionieren auf (LONGINT,LONGINT) *)

PROCEDURE Dict_Add       (key, value: SCHLUESSEL);
FUNCTION  Dict_Find      (key:        SCHLUESSEL;
                          VAR  value: SCHLUESSEL) : BOOLEAN;
FUNCTION  Dict_FindValue (value:      SCHLUESSEL;
                          VAR  key:   SCHLUESSEL) : BOOLEAN;
FUNCTION  Dict_Delete    (key:        SCHLUESSEL) : BOOLEAN;
PROCEDURE Dict_Clear;
FUNCTION  Dict_Count                              : LONGINT;
PROCEDURE Dict_Liste;

(* II_Dict Funktionen funktionieren auf (LONGINT,LONGINT)
   nr sollte nur 1..10 verwendet werden                   *)

PROCEDURE Dict_II_Add       (nr: INTEGER; key, value: I_SCHLUESSEL);
FUNCTION  Dict_II_Find      (nr: INTEGER; key:        I_SCHLUESSEL;
                                          VAR  value: I_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_II_FindValue (nr: INTEGER; value:      I_SCHLUESSEL;
                                          VAR  key:   I_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_II_Delete    (nr: INTEGER; key:        I_SCHLUESSEL) :BOOLEAN;
PROCEDURE Dict_II_Clear     (nr: INTEGER);
FUNCTION  Dict_II_Count     (nr: INTEGER)                           :LONGINT;
PROCEDURE Dict_II_Liste     (nr: INTEGER);

(* SS_Dict Funktionen funktionieren auf (STRING,STRING)
   nr sollte nur 1..10 verwendet werden                   *)

PROCEDURE Dict_SS_Add       (nr: INTEGER; key, value: S_SCHLUESSEL);
FUNCTION  Dict_SS_Find      (nr: INTEGER; key:        S_SCHLUESSEL;
                                          VAR  value: S_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_SS_FindValue (nr: INTEGER; value:      S_SCHLUESSEL;
                                          VAR  key:   S_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_SS_Delete    (nr: INTEGER; key:        S_SCHLUESSEL) :BOOLEAN;
PROCEDURE Dict_SS_Clear     (nr: INTEGER);
FUNCTION  Dict_SS_Count     (nr: INTEGER)                           :LONGINT;
PROCEDURE Dict_SS_Liste     (nr: INTEGER);

PROCEDURE Heap_Info;

IMPLEMENTATION

USES Stdio;

CONST suche     : LONGINT = 0;

TYPE  II_ZEIGER = ^II_SATZ;
      II_SATZ = RECORD
         key:    I_SCHLUESSEL;
         value:  I_SCHLUESSEL;
         link:   II_ZEIGER;
      END;

      II_DICT_TYPE = RECORD
         anzahl, aktuell : LONGINT;
         anker, ende, akt, pos, hilfe, vorher, loesch: II_ZEIGER;
      END;

      SS_ZEIGER = ^SS_SATZ;
      SS_SATZ = RECORD
         key:    S_SCHLUESSEL;
         value:  S_SCHLUESSEL;
         link:   SS_ZEIGER;
      END;

      SS_DICT_TYPE = RECORD
         anzahl, aktuell : LONGINT;
         anker, ende, akt, pos, hilfe, vorher, loesch: SS_ZEIGER;
      END;

VAR II_dict: ARRAY[0..10] OF II_DICT_TYPE;
    SS_dict: ARRAY[0..10] OF SS_DICT_TYPE;

{$IFNDEF DOS} HeapStatusFPC: TFPCHeapStatus; {$ENDIF}

PROCEDURE II_Show(akt: II_ZEIGER);
BEGIN
   WriteLN('Key: ', akt^.key, ', Value: ', akt^.value);
END;

PROCEDURE II_Show2(akt: II_ZEIGER; nr: INTEGER);
BEGIN
   WITH II_dict[nr] DO
      WriteLN('Key: ', akt^.key, ', Value: ', akt^.value,
              ', Nummer: ', aktuell,'/',anzahl,
              ', size=',sizeof(akt^));
END;

PROCEDURE Dict_II_Add(nr: INTEGER; key, value: I_SCHLUESSEL);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      INC(anzahl); INC(aktuell);
      NEW(akt);
      akt^.key:=key;
      akt^.value:=value;
      akt^.link:=NIL;

      (* Liste noch leer *)
      IF anker=NIL THEN BEGIN
         anker:=akt; ende:=akt;
      END

      (* eventuell vorne einfgen? *)
      ELSE
         IF key <= anker^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = anker^.key
               THEN BEGIN
                  anker^.value:=akt^.value;
                  Dispose(akt); akt:=anker;
               END
            (* ansonsten davor einfgen *)
               ELSE BEGIN
                  akt^.link:=anker;
                  anker:=akt;
               END
         END

      (* oder hinten anhngen? *)
      ELSE
         IF key >= ende^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = ende^.key
               THEN BEGIN
                  ende^.value:=akt^.value;
                  Dispose(akt); akt:=ende;
               END
            (* ansonsten hinten anhngen *)
               ELSE BEGIN
                  ende^.link:=akt;
                  ende:=akt;
               END
         END

      (* oder mittendrin einfgen? *)
      ELSE BEGIN
         pos:=anker; hilfe:=pos^.link;
         WHILE(hilfe^.key <= key) DO BEGIN
            INC(suche);
            pos:=pos^.link;
            hilfe:=pos^.link;
         END;
         (* wenn vorhanden, nur updaten *)
         IF key = pos^.key
            THEN  BEGIN
               pos^.value:=akt^.value;
               Dispose(akt); akt:=pos;
            END
         (* ansonsten mittendrin einfgen *)
            ELSE BEGIN
               akt^.link:=pos^.link;
               pos^.link:=akt;
            END
      END;
      II_Show2(akt, nr); WriteLN('Suche: ',suche);
   END;
END;

PROCEDURE Dict_II_Liste(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      akt:=anker;
      WHILE akt<>NIL DO BEGIN
         II_Show(akt);
         akt:=akt^.link;
      END;
   END;
END;

PROCEDURE Dict_II_Clear(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      WHILE anker<>NIL DO BEGIN
         akt:=anker; anker:=anker^.link;
         Dispose(akt);
      END;
      anker:=NIL; ende:=NIL; akt:=NIL; pos:=NIL; hilfe:=NIL;
      vorher:=NIL; loesch:=NIL; anzahl:=0; aktuell:=0;
   END;
END;

FUNCTION Dict_II_Count(nr: INTEGER): LONGINT;
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      akt:=anker;
      anzahl:=0;
      WHILE akt<>NIL DO BEGIN
         INC(anzahl);
         akt:=akt^.link;
      END;
      Dict_II_Count:=anzahl;
   END;
END;

FUNCTION Dict_II_Find(nr: INTEGER; key: I_SCHLUESSEL; VAR value: I_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   value:=-1; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF key = akt^.key
            THEN BEGIN
               gefunden:=True;
               loesch:=akt;
               value:=akt^.value;
            END
            ELSE vorher:=akt;
         akt:=akt^.link;
      END;
   END;
   Dict_II_Find:=gefunden;
END;

FUNCTION Dict_II_FindValue(nr: INTEGER; value: I_SCHLUESSEL; VAR key: I_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   key:=-1; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF value = akt^.value THEN BEGIN
            gefunden:=True;
            key:=akt^.key;
         END;
         akt:=akt^.link;
      END;
   END;
   Dict_II_FindValue:=gefunden;
END;

FUNCTION Dict_II_Delete(nr: INTEGER; key: I_SCHLUESSEL): BOOLEAN;
VAR ok: BOOLEAN;
    dummy: I_SCHLUESSEL;
BEGIN
   ok:= False;
   WITH II_dict[nr] DO BEGIN
      IF Dict_II_Find(nr, key, dummy) THEN BEGIN
         (* es wird am Anfang gelscht *)
         IF loesch = anker THEN
            (* es sind noch weitere Eintrge da *)
            IF loesch^.link <> NIL THEN anker:=loesch^.link ELSE
         (* es wird am Ende gelscht *)
         ELSE
            IF loesch = ende THEN
            (* es sind noch weitere Eintrge da *)
              IF vorher <> NIL THEN vorher^.link:=loesch^.link ELSE
         (* es wird mittendrin gelscht, Vorgnger und Nachfolger mssen da sein! *)
         ELSE IF (loesch <> anker) AND (loesch <> ende)
            THEN vorher^.link:=loesch^.link;
         (* loesch ist jetzt ausgehngt *)
         {loesch^.link:=NIL;}
         {loesch^.key:=-1;}
         {loesch^.value:=-77;}
         IF loesch = anker
            THEN Dict_II_Clear(0)
            ELSE BEGIN Dispose(loesch); DEC(anzahl); END;
         ok:= True;
      END
   END;
   Dict_II_Delete:=ok;
END;

PROCEDURE SS_Show(akt: SS_ZEIGER);
BEGIN
   WriteLN('Key: ', akt^.key, ', Value: ', akt^.value);
END;

PROCEDURE SS_Show2(akt: SS_ZEIGER; nr: INTEGER);
BEGIN
   WITH SS_dict[nr] DO
      WriteLN('Key: ', akt^.key, ', Value: ', akt^.value,
              ', Nummer: ', aktuell,'/',anzahl,
              ', size=',sizeof(akt^));
END;

PROCEDURE Dict_SS_Add(nr: INTEGER; key, value: S_SCHLUESSEL);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      INC(anzahl); INC(aktuell);
      NEW(akt);
      akt^.key:=key;
      akt^.value:=value;
      akt^.link:=NIL;

      (* Liste noch leer *)
      IF anker=NIL THEN BEGIN
         anker:=akt; ende:=akt;
      END

      (* eventuell vorne einfgen? *)
      ELSE
         IF key <= anker^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = anker^.key
               THEN BEGIN
                  anker^.value:=akt^.value;
                  Dispose(akt); akt:=anker;
               END
            (* ansonsten davor einfgen *)
               ELSE BEGIN
                  akt^.link:=anker;
                  anker:=akt;
               END
         END

      (* oder hinten anhngen? *)
      ELSE
         IF key >= ende^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = ende^.key
               THEN BEGIN
                  ende^.value:=akt^.value;
                  Dispose(akt); akt:=ende;
               END
            (* ansonsten hinten anhngen *)
               ELSE BEGIN
                  ende^.link:=akt;
                  ende:=akt;
               END
         END

      (* oder mittendrin einfgen? *)
      ELSE BEGIN
         pos:=anker; hilfe:=pos^.link;
         WHILE(hilfe^.key <= key) DO BEGIN
            INC(suche);
            pos:=pos^.link;
            hilfe:=pos^.link;
         END;
         (* wenn vorhanden, nur updaten *)
         IF key = pos^.key
            THEN  BEGIN
               pos^.value:=akt^.value;
               Dispose(akt); akt:=pos;
            END
         (* ansonsten mittendrin einfgen *)
            ELSE BEGIN
               akt^.link:=pos^.link;
               pos^.link:=akt;
            END
      END;
      SS_Show2(akt, nr); WriteLN('Suche: ',suche);
   END;
END;

PROCEDURE Dict_SS_Liste(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      akt:=anker;
      WHILE akt<>NIL DO BEGIN
         SS_Show(akt);
         akt:=akt^.link;
      END;
   END;
END;

PROCEDURE Dict_SS_Clear(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      WHILE anker<>NIL DO BEGIN
         akt:=anker; anker:=anker^.link;
         Dispose(akt);
      END;
      anker:=NIL; ende:=NIL; akt:=NIL; pos:=NIL; hilfe:=NIL;
      vorher:=NIL; loesch:=NIL; anzahl:=0; aktuell:=0;
   END;
END;

FUNCTION Dict_SS_Count(nr: INTEGER): LONGINT;
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      akt:=anker;
      anzahl:=0;
      WHILE akt<>NIL DO BEGIN
         INC(anzahl);
         akt:=akt^.link;
      END;
      Dict_SS_Count:=anzahl;
   END;
END;

FUNCTION Dict_SS_Find(nr: INTEGER; key: S_SCHLUESSEL; VAR value: S_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   value:=''; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF key = akt^.key
            THEN BEGIN
               gefunden:=True;
               loesch:=akt;
               value:=akt^.value;
            END
            ELSE vorher:=akt;
         akt:=akt^.link;
      END;
   END;
   Dict_SS_Find:=gefunden;
END;

FUNCTION Dict_SS_FindValue(nr: INTEGER; value: S_SCHLUESSEL; VAR key: S_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   key:=''; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF value = akt^.value THEN BEGIN
            gefunden:=True;
            key:=akt^.key;
         END;
         akt:=akt^.link;
      END;
   END;
   Dict_SS_FindValue:=gefunden;
END;

FUNCTION Dict_SS_Delete(nr: INTEGER; key: S_SCHLUESSEL): BOOLEAN;
VAR ok: BOOLEAN;
    dummy: S_SCHLUESSEL;
BEGIN
   ok:= False;
   WITH SS_dict[nr] DO BEGIN
      IF Dict_SS_Find(nr, key, dummy) THEN BEGIN
         (* es wird am Anfang gelscht *)
         IF loesch = anker THEN
            (* es sind noch weitere Eintrge da *)
            IF loesch^.link <> NIL THEN anker:=loesch^.link ELSE
         (* es wird am Ende gelscht *)
         ELSE
            IF loesch = ende THEN
            (* es sind noch weitere Eintrge da *)
              IF vorher <> NIL THEN vorher^.link:=loesch^.link ELSE
         (* es wird mittendrin gelscht, Vorgnger und Nachfolger mssen da sein! *)
         ELSE IF (loesch <> anker) AND (loesch <> ende)
            THEN vorher^.link:=loesch^.link;
         (* loesch ist jetzt ausgehngt *)
         {loesch^.link:=NIL;}
         {loesch^.key:=-1;}
         {loesch^.value:=-77;}
         IF loesch = anker
            THEN Dict_SS_Clear(0)
            ELSE BEGIN Dispose(loesch); DEC(anzahl); END;
         ok:= True;
      END
   END;
   Dict_SS_Delete:=ok;
END;

PROCEDURE Heap_Info;
VAR memovoll: LONGINT;
BEGIN
   {$IFDEF DOS} WriteLN('HEAP    Speicher frei: ' + StrCardInt(MEMAVAIL));
   {$ELSE}
   HeapStatusFPC:=GetFPCHeapStatus;
   memovoll:=HeapStatusFPC.CurrHeapUsed;
   WriteLN('HEAP    Speicher max:  ' + StrCardInt(HeapStatusFPC.MaxHeapUsed)
                                 + '/' + StrCardInt(HeapStatusFPC.MaxHeapSize));
   WriteLN('HEAP    Speicher frei: ' + StrCardInt(HeapStatusFPC.CurrHeapFree)
                                 + '/' + StrCardInt(HeapStatusFPC.CurrHeapSize));
   WriteLN('HEAP    Speicher voll: ' + StrCardInt(memovoll));
   {$ENDIF}
END;

PROCEDURE Dict_Add(key, value: I_SCHLUESSEL);
BEGIN
   Dict_II_Add(0, key, value);
END;

PROCEDURE Dict_Liste;
BEGIN
   Dict_II_Liste(0);
END;

PROCEDURE Dict_Clear;
BEGIN
   Dict_II_Clear(0);
END;

FUNCTION Dict_Count: LONGINT;
BEGIN
   Dict_Count:=Dict_II_Count(0);
END;

FUNCTION Dict_Find(key: I_SCHLUESSEL; VAR value: SCHLUESSEL):BOOLEAN;
VAR ok: BOOLEAN;
    ergebnis: SCHLUESSEL;
BEGIN
   Dict_Find:=Dict_II_Find(0, key, value);
END;

FUNCTION Dict_FindValue(value: SCHLUESSEL; VAR key: SCHLUESSEL):BOOLEAN;
VAR ok: BOOLEAN;
    ergebnis: SCHLUESSEL;
BEGIN
   Dict_FindValue:=Dict_II_FindValue(0, value, key);
END;

FUNCTION Dict_Delete(key: SCHLUESSEL):BOOLEAN;
BEGIN
   Dict_Delete:=Dict_II_Delete(0, key);
END;

BEGIN
   Dict_II_Clear(0);

END (* Dict20 *).
