{$D+}
unit Ansi2UTF;         {(c) Alfware Bernd Schubert 10.03.2020}

{$ifndef dos} {$h+} {$endif}

interface

function string_UTF2Ansi(s: string): string;

function string_Ansi2UTF(s: string): string;

implementation

const anzahl = 11;
   source: array[0..anzahl] of string[20] = (
   'NR  CHR ANS UTF EXT ',
   '001    142 195 132 ',
   '002    153 195 150 ',
   '003    154 195 156 ',
   '004    132 195 164 ',
   '005    148 195 182 ',
   '006    129 195 188 ',
   '007    225 195 159 ',
   '008    248 194 176 ',
   '009    253 194 178 ',
   '010    252 194 179 ',
   '011    245 194 167 ');

var  utf1, utf2, ansi: array[1..255] of integer;

procedure analyse;
var i: integer; w: word;
    {nr,} iutf1,iutf2, iansi: integer;
    {zeichen : char;}
    s: string;
begin
   for i:=1 to anzahl do begin
      utf1[i]:=0; ansi[i]:=0;
   end;
   for i:=1 to anzahl do begin
      s:=source[i];
      {val (copy(s, 1, 3), nr, w); }
      val (copy(s, 9, 3), iansi, w);
      val (copy(s, 13, 3), iutf1, w);
      val (copy(s, 17, 3), iutf2, w);
      {zeichen:=s[5];}
      ansi[i]:= iansi;
      utf1[i]:= iutf1;
      utf2[i]:= iutf2;
   end;
end;

function char_ansi2UTF(c: char): string;
var i : integer;
    gefunden: boolean;
begin
   gefunden:=false; i:=1;
   while (i <= anzahl) and not gefunden do begin
      if ansi[i] = ord(c) then gefunden:= true;
      inc(i);
   end;
   if gefunden
      then char_ansi2UTF:= chr( utf1[i-1] ) + chr( utf2[i-1] )
      else char_ansi2UTF:= '' + c;
end;

function char_UTF2ansi(s: string): char;
var i : integer;
    gefunden: boolean;
begin
   if length(s) = 1
      then char_UTF2ansi:= s[1]
      else begin
         gefunden:=false; i:=1;
         while (i <= anzahl) and not gefunden do begin
            if (utf1[i] = ord( s[1] )) and (utf2[i] = ord( s[2] ))
               then gefunden:=true;
            inc(i);
        end;
        if gefunden
           then char_UTF2ansi:=chr( ansi[i-1] )
           else char_UTF2ansi:='?';
      end;
end;

function string_Ansi2UTF(s: string): string;
var i: integer; c: char; temp: string;
begin
   temp:='';
   for i:=1 to Length(s) do begin
      c:= s[i]; temp:=temp + char_ansi2UTF(c);
   end;
   string_Ansi2UTF:=temp;
end;

function string_UTF2Ansi(s: string): string;
var i: integer; cs, temp: string;
begin
   temp:=''; i:=1;
   while i <= length(s) do begin
      cs:= s[i];
      if (ord( s[i] ) in [194..195]) then begin
         inc(i); cs:= cs + s[i];
      end;
      temp:= temp + char_UTF2ansi(cs);
      inc(i);
   end;
   string_UTF2Ansi:=temp;
end;

begin
   Analyse;
end.
